<?php
/*
noCopyright(C) 程式設計 台中縣網 張本和 axer@ms1.boe.tcc.edu.tw 981006-08
版權宣告：無，歡迎修改使用。
ver 1.1
98.11.25新增功能：新增非固定網段的判斷，連線單位的ip6網段在資料庫中可以是不同的 prefix，由資料庫的記錄為準。
例如 2001:288:5410/48 : xx 國小；2001:288:54F2/64 : oo幼稚園

*/

define('ValidAccess', true);
include "init.php";

$f= (empty($_POST["f"]))? (empty($_GET["f"])? "none":$_GET["f"]):$_POST["f"];
$f=trim($f);    //hacking proof

$view->assign('obj', $obj);
/*
if ( ! in_array($f, $_SESSION['priv'])){
    $msg = $PRIV_ERR. $obj->JS_CountDownString( "index.php", 3000, false);
    $view->assign('msg',  $msg);
    $view->display('msg.mtpl');
    exit;
}
*/

$obj->SetSession($_SESSION);    //將 _SESSION 傳遞給物件
$obj->SCHS_PER_ROW = $SCHS_PER_ROW;

switch($f){
  case "CheckIPv6Conn":
	$hn= trim($_POST['hn']);
    $hn = preg_replace('/[^\w\-.]/', '', $hn);	
	$IsOk=exec("./ipv6_1line.pl {$hn}");
	$ERR_Code= array(
      2=>"已和網頁伺服器建立IPv6連線，但無法取回網頁標頭<BR>Already established connection with www server on IPv6, but failed to get header.",
      1=>"網頁IPv6介面正常，能正常取回資料<BR>Successfully establish connection with www server on IPv6",
      0=>"無法取得正確的檢測結果，參數錯誤。<BR>Failed to acquire results, maybe wrong or bad parameters.",
     -1=>"DNS無法查詢，此網域不存在。<BR>DNS query failed, domain does not exist.",
     -2=>"無法和網頁伺服器IPv6介面建立連線，請檢查防火牆或是網頁伺服器設定。<BR>Cannot establish connection with www server on IPv6, but this www server has a DNS AAAA record. Check the firewall or www service settings.",
     -3=>"查詢DNS IPv6之AAAA記錄失敗，請重試<BR>DNS query failed, please retry.",
     -4=>"此網域無IPv6 AAAA記錄<BR>This domain has no DNS AAAA record.",
     -5=>"DNS查詢失敗，無此網域或此網域無位址記錄。<BR>DNS query failed, domain does not exist or missing address record."
    );
	$arr= explode(',', $IsOk);
	$state = $arr[0];
	if($state >0) print "<font color=#20009F>".$hn." ". $ERR_Code[$state]. "</font>";
    else print "<font color=darkgray>".$hn." ". $ERR_Code[$state]. "</font>";
	if( $state != -5 )$obj->SaveIPv6CheckRec( $hn, $state, $arr);
    break;

  case "ClickCount":   //AJAX
    $sn= (int)$_POST['sn'];
    $chk=false;
	if( isset ( $_SESSION["clicked"] )){
      if( !in_array( $sn ,  $_SESSION["clicked"] ) ){
        array_push($_SESSION["clicked"], $sn);
        $chk=true;
      }
	}else{
      $_SESSION["clicked"] = array($sn);
      $chk=true;
	}
    if($chk) $obj->ProcClickCount($sn);
    break;    

  case "ListEnableHosts":
    $view->display('IPv6EnableList.tpl');
	break;

  case "TitleInstr":
    $view->display('TitleInstr.tpl');
    break;

  case "NONE":
	break;

  default:
	$ip6=strtoupper($_SERVER["REMOTE_ADDR"]);	//取前三節改大寫

		$iarr = explode (":", $ip6, 2);
		if( sizeof( $iarr)<=1 ){
			$v6="no";
			$schname ="IPv4的單位";
		}
		else{
		  $v6="yes";	
		  $arr= $obj->GetSchNameByIP6_( $ip6);
		  if( ! $arr) $schname ="其他單位";
		  else{
			$schname= $arr['schname'];
			$IsUpDate=false;
			if( ! $arr['recIP'] )$IsUpDate=true;
			$arr['recIP'] = $ip6;
			$arr['recDT'] = date("Y-m-d H:i:s");	//0000-00-00 00:00:00
			if( $IsUpDate)$obj->ProcSaveIP6Rec( $arr );
			else
				if( empty( $_SESSION['in'] )){
					$obj->ProcSaveIP6Count( $arr, $ENABLE_REC_EACH_IP6 );
					$_SESSION['in'] =1;
				}
		  }
		}
        $view->assign('v6',  $v6);
        $view->assign('schname',  $schname);
	    $view->assign('ip6',  $ip6 );
		
		$view->display('Index.tpl');

}

